#!/bin/sh
GWVER=2.2

echo -e "\n\nLoading AODV Gateway version $GWVER...\n"

IPTABLES=/sbin/iptables
KERNEL_AODV=kernel_aodv

EXTIF="eth0"  #interface to use for gatewaying
INTIF="wlan0"   #interface to connect to AODV Network

# The node will assume all destinations that are not in INTIF's
# subnet are on the internet and not part of the AODV subnet.
# Because of this you may have to alter INTIF's subent to match
# the subnet that all of the other AODV nodes are one.


echo "	Gateway Interface: $EXTIF"
echo "	AODV Interface: $INTIF"

echo "	Enabling IP forwarding"
echo "1" > /proc/sys/net/ipv4/ip_forward

echo "  Zero MIN_DELAY for routing table changes"
echo "0" > /proc/sys/net/ipv4/route/min_delay

$IPTABLES -A FORWARD -i $EXTIF -o $INTIF -m state --state ESTABLISHED,RELATED -j ACCEPT
$IPTABLES -A FORWARD -i $INTIF -o $EXTIF -j ACCEPT

echo "	Enabling Masquerading on $EXTIF"
$IPTABLES -t nat -A POSTROUTING -o $EXTIF -j MASQUERADE

echo "	Starting Kernel AODV..."
echo

insmod $KERNEL_AODV use_dev=$INTIF aodv_gateway=1
